%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                  PSG Type    PSG Object         Location in Problem Statement                        Class
%vector_qi_data          data        vector_qi          kantor(parameter_alpha,vector_Yi_norm, vector_qi)    double
%vector_yi_norm_data     data        vector_yi_norm     n/a                                                  double
%parameter_alpha_data    data        parameter_alpha    kantor(parameter_alpha,vector_Yi_norm, vector_qi)    double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(vector_qi_data,vector_yi_norm_data,parameter_alpha_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = vector_pack('vector_qi',vector_qi_data);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_yi_norm',vector_yi_norm_data);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'problem_Kantor_no_init, minimize',...
'  kantor(parameter_alpha,vector_Yi_norm, vector_qi)',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_alpha',parameter_alpha_data);

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

